-- 夺宝奇兵逃杀场景界面
checkRequire("Lua_SnatchWarLeftInfoPanel");
Lua_SnatchWarFightingWindow = class("Lua_SnatchWarFightingWindow", Lua_FullSizeWindow);
function Lua_SnatchWarFightingWindow:ctor()
	self:superCall("ctor", false, false, 500, false, false, false);

	self.windowName = "Lua_SnatchWarFightingWindow";
end

function Lua_SnatchWarFightingWindow:buildShowItem()
	self:superCall("buildShowItem");

	-- 遮罩，倒计时完去除
	self.blackBg = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_black_50", 0, 0, 1280, 720);
	self.blackBg.name = "blackBg";
	self.blackBg.alpha = 0.5;
	self.blackBg:setDepth(20);
	self.blackBg:setEnable(false);

	self.leftInfoPanel = Lua_SnatchWarLeftInfoPanel.new(self.content);
	self.leftInfoPanel:setLocation(-MainWinDefine.V_width / 2 + 640, 0, 0);

	self.blackBg:addClickFuntion(self, self.onBlackBgClick);

	self:addLuaEvent("rSnatchWarInfo", self, self.onUpdateFightInfo);
	self:addLuaEvent("rSnatchWarLeftSec", self, self.onUpdateCountDown);
	self:addLuaEvent("MENU_OUT_CLICK", self, self.onExitSnatchWarScene);
end

function Lua_SnatchWarFightingWindow:onBlackBgClick(go)
end

-- 战斗信息
function Lua_SnatchWarFightingWindow:onUpdateFightInfo()
	if self.leftInfoPanel ~= nil then
		self.leftInfoPanel:updateSnatchWarInfo();
	end
end

-- 开始倒计时
function Lua_SnatchWarFightingWindow:onUpdateCountDown()
	if GlobalVar.hooking then
		DataCenter.hook:stop(true);
	end

	local num = DataCenter.snatchWarData.fightCountDown;
	if num > 0 then
		if self.countDownAni == nil then
			self.countDownAni = Lua_CountDownAnimation.new(self.content, self, self.countDownComplete);
			self.countDownAni:setDepth(10);
		end
		self.countDownAni:playCountDown(num, 1);
	else
		self:countDownComplete();
	end
end

function Lua_SnatchWarFightingWindow:countDownComplete()
	if self.leftInfoPanel ~= nil then
		self.leftInfoPanel:startSnatchWarFightTime();
	end
	if self.countDownAni ~= nil then
		self.countDownAni:dispose();
		self.countDownAni = nil;
	end
	self.blackBg:setEnable(false);
end

function Lua_SnatchWarFightingWindow:onExitSnatchWarScene()
	Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = self, des = LanUtil.getValue(123111), type = 1, subFun = self.onOutClick});
end

function Lua_SnatchWarFightingWindow:onOutClick(val)
	Lua_ProxyManager.getProxy("Lua_SnatchWarProxy"):sExitScene();
end

function Lua_SnatchWarFightingWindow:dispose()
	if self.leftInfoPanel ~= nil then
		self.leftInfoPanel:dispose();
		self.leftInfoPanel = nil;
	end
	if self.countDownAni ~= nil then
		self.countDownAni:dispose();
		self.countDownAni = nil;
	end

    self:superCall("dispose");
end