-- 夺宝奇兵任务提交面板
checkRequire("Lua_RewardItem");
Lua_SnatchWarTaskWindow = class("Lua_SnatchWarTaskWindow", Lua_Window);
function Lua_SnatchWarTaskWindow:ctor()
	self:superCall("ctor");

	self.blackAlpha = 180 / 255;
	self.isClickClose = true;
	self.showClose = false;

	self.windowName = "Lua_SnatchWarTaskWindow";
	self.skinName = "SnatchWarTaskWindow_skin";
end

function Lua_SnatchWarTaskWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.npcImg:setEnable(false);

	self.npcWinBg.clickScale = false;
	self.npcWinBg:addClickFuntion(self, self.onBgClick);

	self.giftVo = DataCenter.snatchWarData.curOwnSnatchWarGiftVo;
	if self.giftVo ~= nil then
		self.rItem = Lua_RewardItem.new(self.content);
		self.rItem.pivot = 2;
		self.rItem:setLayout(72, 72, 4);
		self.rItem:setMaxShow(4);
		self.rItem:setDepth(10);
		self.rItem:setClickWin(true);
		self.rItem:setMouseEnble(true);
		self.rItem:setItemScale(0.8, 0.8);
	 	self.rItem:setLocation(150, -285, 0);
		self.rItem:setRewardByRewardList(Array(self.giftVo.rewardId));

		self.descTxt.text = self.giftVo.taskDesc;
	end

	self.getRewardBtn:setEnable(self.giftVo ~= nil);
	self.getRewardBtn:addClickFuntion(self, self.onGetRewardClick);
end

function Lua_SnatchWarTaskWindow:showWin(param)
	self:superCall("showWin", param);

	self.npc = param.npc;
	if self.npc ~= nil then
		self.npcPoint = Vector3(self.npc.posX, self.npc.posY, self.npc.posZ);
		if self.bRegisterTimer ~= true then
			self.bRegisterTimer = true;
			Lua_CommonUtil.addTimer("Lua_SnatchWarTaskWindow", 0.1, self, self.snatchWarNpcDistanceCloseWin);
		end

		if self.npc.imgUrl ~= nil then
			self.npcImg:SetDimensions(0, 0);
			self.npcImg:setUrl(self.npc.imgUrl);
			self.npcImg:setEnable(true);
		end

		self.taskNameTxt.text = self.npc.kind;
		if self.giftVo == nil then
			self.descTxt.text = self.npc.desc;
		end
	end
end

function Lua_SnatchWarTaskWindow:onGetRewardClick()
	if self.giftVo ~= nil then
		Lua_ProxyManager.getProxy("Lua_SnatchWarProxy"):sExchangeGift(self.giftVo.giftId); -- 进入场景
	end
	self:hide();
end

function Lua_SnatchWarTaskWindow:clearTimer()
	if self.bRegisterTimer == true then
		self.bRegisterTimer = false;
		Lua_CommonUtil.removeTimer(self, self.snatchWarNpcDistanceCloseWin);
	end
end

function Lua_SnatchWarTaskWindow:snatchWarNpcDistanceCloseWin()
	local rolePlayer = ThingUtil.instance:getThingById(DataCenter.roleData.roleId);
	if rolePlayer ~= nil then
		local sp = rolePlayer.currentPoint;
		if Vector3.Distance(sp, self.npcPoint) > 200 then
			self:hide();
		end
	end
end

function Lua_SnatchWarTaskWindow:dispose()
	if self.rItem ~= nil then
		self.rItem:dispose();
		self.rItem = nil;
	end
	self:clearTimer();
	self.giftVo = nil;

	self:superCall("dispose");
end