-- 夺宝奇兵入口
Lua_SnatchWarWindow = class("Lua_SnatchWarWindow", Lua_SecondSizeWindow);
function Lua_SnatchWarWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_SnatchWarWindow";
	self.skinName = "SnatchWarWindow_skin";
	self.titleText = LanUtil.getValue(123100);
end

function Lua_SnatchWarWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.descBg.imgTypeNum = 4;
	self.descBg.widget.border = Vector4(0, 10, 0, 10);

	self.desLab.text = LanUtil.getValue(123102);
	self.tipsLab.text = LanUtil.getValue(123104);

	local activityVo = DataCenter.xianshiData:getDataById(getConfig({"indiana_const", "activity_id", "val"}));
	self.timeLab.text = LanUtil.formateStr(LanUtil.getValue(123101), activityVo.openTimeDesc);

	self.rItem = Lua_RewardItem.new(self.content);
	self.rItem:setLayout(90, 90, 9);
	self.rItem:setMaxShow(9);
	self.rItem:setDepth(10);
	self.rItem:setClickWin(true);
	self.rItem:setMouseEnble(true);
	self.rItem:setItemScale(1, 1);
	self.rItem:setLocation(304, -155, 0);
	self.rItem:setRewardByRewardList(Array(activityVo.display_reward));

	self.tipsIcon:addClickFuntion(self, self.onHelp);
	self.tipsLab:addClickFuntion(self, self.onHelp);
	self.enterBtn:addClickFuntion(self, self.onEnterBtnClick);
end

function Lua_SnatchWarWindow:onHelp(go)
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, LanUtil.getValue(123105));
end

-- 夺宝大逃杀场景(注意场景id写死，配置修改的时候也得改)
function Lua_SnatchWarWindow:onEnterBtnClick(go)
	if DataCenter.snatchWarData.bInSnatchWarScene then
		OperateAlert.show(LanUtil.getValue(121805));
		return;
	end
	Lua_ProxyManager.getProxy("Lua_SnatchWarProxy"):sEnterSnatchWarScene(); -- 进入场景
end

function Lua_SnatchWarWindow:dispose()
	if self.rItem ~= nil then
		self.rItem:dispose();
		self.rItem = nil;
	end
	self:superCall("dispose");
end