-- 夺宝左侧信息栏面板
Lua_SnatchWarLeftInfoPanel = class("Lua_SnatchWarLeftInfoPanel", Lua_DisplayObject);
function Lua_SnatchWarLeftInfoPanel:ctor(p)
	self:superCall("ctor", p, "SnatchWarLeftInfoPanel_skin");
end

function Lua_SnatchWarLeftInfoPanel:buildShowItem()
	self:superCall("buildShowItem");

	self._showState = true;
	self.txtArr = Array();
	self.titleTxt.text = LanUtil.getValue(123110);

	self:updateSnatchWarInfo();

	self.titleBg.clickScale = false;
	self.bg.clickScale = false;
	self.timeBg.clickScale = false;
	self.titleBg:addClickFuntion(self, self.onBgClick);
	self.bg:addClickFuntion(self, self.onBgClick);
	self.timeBg:addClickFuntion(self, self.onBgClick);
	self.closeBtn:addClickFuntion(self, self.onArrowBtnClick);
	self.tipsIcon:addClickFuntion(self, self.onTipsClick);
end

-- 更新信息
function Lua_SnatchWarLeftInfoPanel:updateSnatchWarInfo()
	self:updateGiftInfo();
	self:startSnatchWarFightTime();
	-- local num = DataCenter.snatchWarData.fightCountDown;
	-- if num > 0 then
	-- 	self:clearTimer();
	-- 	num = DataCenter.snatchWarData.fightResidueTime - num;
	-- else
	-- 	num = DataCenter.snatchWarData.fightResidueTime;
	-- end
	-- self.endTimeTxt.text = LanUtil.formateStr(LanUtil.getValue(123106), TimeTransform.getInstance():transSeconds1(num, true));  
end

function Lua_SnatchWarLeftInfoPanel:updateGiftInfo()
	local arr = DataCenter.snatchWarData.snatchWarGiftArr;
	if arr == nil then
		return;
	end

	local len = self.txtArr:getSize();
	for i = len, len -1 do
		if i > arr:getSize() then
			self.txtArr:setEnable(false);
		end
	end

	local arrLen = arr:getSize();
	local posY;
	local txt;
	for i = 1, arrLen do
		posY = 73 - 28 * (i - 1);
		txt = self.txtArr[i];
		if txt == nil then
			txt = UICreate.createLabel(self.content, "", -618, posY, 246, 22, 20);
			txt.pivot = UIWidget.Pivot.Left;
			txt.overflowMethod = UILabel.Overflow.ResizeFreely;
			txt:setDepth(2);
			self.txtArr:add(txt);
		end
		txt.text = arr[i].showCurDesc;
		txt:setEnable(true);
		txt:setLocation(-618, posY, 0);
	end

	-- npc链接 提交任务：[u][url=npc_904050101]宝藏猎人[/url][/u][-]
	txt = self.txtArr[arrLen + 1];
	if txt == nil then
		posY = 73 - 28 * arrLen;
		txt = UICreate.createLabel(self.content, LanUtil.getValue(123114), -618, posY, 250, 22, 20);
		txt.clickScale = false;
		txt.pivot = UIWidget.Pivot.Left;
		txt.overflowMethod = UILabel.Overflow.ResizeFreely;
		txt:setDepth(2);
		txt:addClickFuntion(self, self.onGotoBtnClick);
		self.txtArr:add(txt);
	end
	txt:setEnable(true);
	self.clickIndex = arrLen + 1;
end

-- 开始计时
function Lua_SnatchWarLeftInfoPanel:startSnatchWarFightTime()
	local num = DataCenter.snatchWarData.fightResidueTime;
	if DataCenter.snatchWarData.fightCountDown > 0 then
		self:clearTimer();
		num = DataCenter.snatchWarData.fightCountDown - num;
	else
		if num > 0 then
			if self.bRegisterTimer ~= true then
	            self.bRegisterTimer = true;
	            Lua_CommonUtil.addTimer("Lua_SnatchWarLeftInfoPanel", 1, self, self.updateSnatchWarTime);
	        end
		end
	end
	self.endTimeTxt.text = LanUtil.formateStr(LanUtil.getValue(123106), TimeTransform.getInstance():transSeconds1(num, true));
end

function Lua_SnatchWarLeftInfoPanel:updateSnatchWarTime()
	local num = DataCenter.snatchWarData.fightResidueTime;
	if num <= 0 then
		num = 0;
		self:clearTimer();
	end
	self.endTimeTxt.text = LanUtil.formateStr(LanUtil.getValue(123106), TimeTransform.getInstance():transSeconds1(num, true)); 
end

function Lua_SnatchWarLeftInfoPanel:clearTimer()
	if self.bRegisterTimer == true then
		self.bRegisterTimer = false;
		Lua_CommonUtil.removeTimer(self, self.updateSnatchWarTime);
	end
end

function Lua_SnatchWarLeftInfoPanel:onBgClick(go)
end

function Lua_SnatchWarLeftInfoPanel:onArrowBtnClick(go)
	if self.clickTime ~= nil and getTime() - self.clickTime < 0.3 then
		OperateAlert.show(LanUtil.getValue(121419));
		return;
	end
	self.clickTime = getTime();

	self:setShowState(not self._showState);
end

function Lua_SnatchWarLeftInfoPanel:onGotoBtnClick(go)
	if self.clickTime ~= nil and getTime() - self.clickTime < 0.3 then
		return;
	end
	self.clickTime = getTime();

	local urlStr = self.txtArr[self.clickIndex]:getUrlByMousePos();
	if urlStr ~= nil then
		local arr = string.split(urlStr, "_");
		if arr[1] == "npc" then
			-- self.giftVo = DataCenter.snatchWarData.curOwnSnatchWarGiftVo;
			-- if self.giftVo ~= nil then
				-- 寻路
				WorldMapUtil.moveTo(DataCenter.roleData.sceneId, 0, 0, 0, tonumber(arr[2]), 7, nil, 0);
			-- else
			-- 	OperateAlert.show(LanUtil.getValue(123113));
			-- end
		end
	end
end

function Lua_SnatchWarLeftInfoPanel:setShowState(val)
	self._showState = val;
	if val then
		self.closeIcon:setSacle(0.8, 0.8);
		self.closeBtn:setLocation(-386.5, 135, 0);
		self.closeIcon:setLocation(-388, 139, 0);
		TweenUtil.getInstance():addTween(self.content, 0.5, 0, Vector3(0, -2, 0), nil, nil);
	else
		self.closeBtn:setLocation(-386.5 + self.closeBtn.width + 13, 135, 0);
		self.closeIcon:setLocation(-388 - 1.5 + self.closeBtn.width + 13, 139, 0);
		self.closeIcon:setSacle(-0.8, 0.8);
		TweenUtil.getInstance():addTween(self.content, 0.5, 0, Vector3(-269, -2, 0), nil, nil);
	end
end

function Lua_SnatchWarLeftInfoPanel:onTipsClick()
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, LanUtil.getValue(123115));
end

function Lua_SnatchWarLeftInfoPanel:dispose()
	if self.txtArr ~= nil then
		self.txtArr:dispose();
		self.txtArr:clear();
		self.txtArr = nil;
	end
	self:clearTimer();
	TweenUtil.getInstance():stop(self.content);

    self:superCall("dispose");
end